<template>
  <v-card class="mx-auto" max-width="500">
    <v-container fluid>
      <v-row dense>
        <v-col>
          <v-card>
            <v-img
              :src="image"
              class="align-end"
              gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
              height="150px"
              cover
              v-if="image !== ''"
            >
            </v-img>
            <v-skeleton-loader
              v-else
              height="240"
              type="image, list-item-two-line"
            />
            <div>
              <v-card-title class="justify-space-between">
                <div :style="{ width: '50%' }">
                  <h4>
                    {{ restaurant | upperCase }}
                  </h4>
                </div>
                <div class="w-15">
                  <v-btn
                    density="compact"
                    icon
                    @click="
                      show = !show;
                      bComment = !bComment;
                    "
                  >
                    <v-icon color="#009688">mdi-comment-edit</v-icon>
                  </v-btn>
                  <v-btn density="compact" icon @click="show = !show">
                    <v-icon>{{
                      show ? "mdi-chevron-up" : "mdi-chevron-down"
                    }}</v-icon>
                  </v-btn>
                  <v-btn size="small" icon density="compact" variant="text">
                    <v-icon>mdi-heart</v-icon>
                  </v-btn>
                </div>
              </v-card-title>

              <v-card-subtitle>
                <v-icon small color="primary">mdi-map-marker</v-icon>
                {{ address }}
                <v-divider />
                <v-icon small color="grey">mdi-phone-classic</v-icon>
                <a :href="'tel:' + phone" class="text-decoration-none">{{
                  phone
                }}</a>
                <div class="mt-1">
                  <v-chip
                    class="mr-1"
                    small
                    label
                    v-for="item in typeFood"
                    :key="item"
                  >
                    <v-icon small>mdi-tag</v-icon> {{ item }}
                  </v-chip>
                </div>
              </v-card-subtitle>
            </div>
            <v-expand-transition>
              <div v-show="show">
                <v-card-text v-if="bComment">
                  <v-text-field
                    v-model="message"
                    append-icon="mdi-send"
                    variant="filled"
                    clear-icon="mdi-close-circle"
                    clearable
                    hint="Los demás podran ver tu comentario :) "
                    placeholder="Escribe una reseña de este lugar"
                    type="text"
                    @click:append="sendMessage(id)"
                  />
                </v-card-text>
                <v-card-text class="text-justify" v-else>
                  <v-rating v-model="nRating" hover></v-rating>
                  <v-divider />
                  {{ descripcion }}
                  <v-divider class="mt-2" />
                  <v-btn icon color="purple" @click="onEnlace(instagram)">
                    <v-icon>mdi-instagram</v-icon>
                  </v-btn>
                </v-card-text>
              </div>
            </v-expand-transition>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </v-card>
</template>
<script>
import RestaurantMixin from "@/mixins/RestaurantMixin.js";
import axios from "axios";
import { mapGetters } from "vuex";
export default {
  name: "restaurant",
  mixins: [RestaurantMixin],
  data() {
    return {
      show: false,
      nRating: this.rating,
      bComment: false,
      message: "",
    };
  },
  filters: {
    upperCase(value) {
      if (!value) return "";
      // Si la variable es diferente de string
      if (typeof value !== "string") {
        return value;
      }
      // El valor contiene caracteres especiales que no se pueden convertir a mayúsculas
      if (/[^a-zA-Z\s]/.test(value)) {
        return value;
      }
      return value.toUpperCase();
    },
  },
  computed: {
    ...mapGetters({
      user: "auth/user",
    }),
  },
  methods: {
    onEnlace(link) {
      if (link) {
        window.open(link, "_blank");
      }
    },
    async sendMessage(id) {
      try {
        const {  data } = await axios.post("/comment", {
          user: this.user._id,
          restaurant: id,
          comment: this.message
        });
        this.message = '';
        alert(data.message)
      } catch (error) {
        console.log(error);
      }
    },
  },
};
</script>